itech/protected/controllers/UserController.php
<?php

/**
 * SiteController is the default controller to handle user requests.
 */
class UserController extends CController
{
	public $layout='management';
	private $_model;

	/**
	 * Index action is the default action in a controller.
	 */
	public function actionIndex()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "VIEW_USER", "CREATE_USER", "UPDATE_USER", "DELETE_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}
		$model = new UserLogin();
		// Make not find self account
		$model->exceptFindId = UserLoginUtil::getUserLoginId();

		// Set Search Text
		if(isset($_GET['search_text'])){
			$model->search_text = addslashes($_GET['search_text']);
			$model->username_search = $usernameSearch;
		}

		$this->render('main', array(
				'data' => $model,
		));
	}
	public function actionStaff()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "VIEW_USER", "CREATE_USER", "UPDATE_USER", "DELETE_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}
		$model = new UserLogin();
		// Make not find self account
		$model->exceptFindId = UserLoginUtil::getUserLoginId();
		$model->onlyStaff = true;

		// Set Search Text
		if(isset($_GET['search_text'])){
			$usernameSearch = addslashes($_GET['search_text']);
			$personalTitleSearch = addslashes($_GET['search_text']);
			$firstNameSearch = addslashes($_GET['search_text']);
			$lastNameSearch = addslashes($_GET['search_text']);
			$emailSearch = addslashes($_GET['search_text']);

			$model->username_search = $usernameSearch;
			$model->user_information_personal_title_search = $personalTitleSearch;
			$model->user_information_first_name_search = $firstNameSearch;
			$model->user_information_last_name_search = $lastNameSearch;
			$model->user_information_email_search = $emailSearch;
		}

		$this->render('staff', array(
				'data' => $model,
		));
	}
	public function actionAssignRoom()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}
		$model = $this->loadModel();

		if(isset($_POST['submit'])) {
			RoomStaff::model()->deleteAll("staff_id='".$model->id."'");
			if(isset($_POST['rooms'])) {
				$rooms = $_POST['rooms'];
				foreach($rooms as $room){
					$rs = new RoomStaff();
					$rs->room_id = $room;
					$rs->staff_id = $model->id;
					$rs->save();
				}
			}
			$this->redirect(Yii::app()->createUrl('User/Staff/'));
		}



		$this->render('assign_room', array(
				'data' => $model,
		));
	}

	public function actionCreate()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "CREATE_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}

		if(isset($_POST['add_user'])){
			$userLogin = new UserLogin();
			$userLogin->attributes = $_POST['UserLogin'];
			$userLogin->password = md5($userLogin->password);

			if($userLogin->save()){
				$userInfo = new UserInformation();
				$userInfo->id = $userLogin->getPrimaryKey();
				$userInfo->attributes = $_POST['UserInformation'];
				if($userInfo->save()){
					$this->redirect(Yii::app()->createUrl('user/view/id/'.$userInfo->id));
				} else {
					$this->render('create');
				}
			}
		} else {
			$this->render('create');
		}

	}
	public function actionDelete()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "DELETE_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}

		$model = $this->loadModel();
		$model->delete();
		$this->redirect(Yii::app()->createUrl('User/'));
	}
	public function actionView()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "VIEW_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}

		$model = $this->loadModel();
		$this->render('view', array(
				'model' => $model,
		));
	}
	public function actionUpdate()
	{
		// Permission
		if(!UserLoginUtil::hasPermission(array("FULL_ADMIN", "UPDATE_USER"))){
			throw new CHttpException(404,Yii::t('yii','The system is unable to find the requested',
					array('{action}'=>$actionID==''?$this->defaultAction:$actionID)));
		}

		$userLogin = $this->loadModel();
		if ($userLogin === null) {
			Yii::log("User not found!", CLogger::LEVEL_INFO, __METHOD__);
			throw new CHttpException(404, Yii::t("MusicModule.general", 'The requested page does not exist.'));
		}

		if(isset($_POST['UserLogin'])) {
			if($_POST['UserLogin']['password'] == '') {
				$_POST['UserLogin']['password'] = md5($userLogin->password);
			} else {
				$_POST['UserLogin']['password'] = md5($_POST['UserLogin']['password']);
			}
			$userLogin->attributes = $_POST['UserLogin'];
			var_dump($userLogin->attributes);
			if($userLogin->update()) {
				$userInfo = UserInformation::model()->findByPk($userLogin->id);
				if(isset($userInfo)){
					$userInfo->attributes = $_POST['UserInformation'];
					if($userInfo->update()){
						$this->redirect(Yii::app()->createUrl('user/view/id/'.$userInfo->id));
					}
				}
			}
		} else {
			$this->render('update', array(
					'model' => $userLogin,
			));
		}


	}

	public function loadModel()
	{
		if($this->_model===null)
		{
			if(isset($_GET['id']))
				$this->_model=UserLogin::model()->findbyPk($_GET['id']);
			if($this->_model===null)
				throw new CHttpException(404,'The requested page does not exist.');
		}
		return $this->_model;
	}


}

itech/protected/views/user/assign_room.php
<div class="module-head">
	<span>Manage Rooms</span>
</div>
<div>
	<?php 
	$rooms = Room::model()->findAll();
	

	$form = $this->beginWidget('CActiveForm', array(
			'id' => 'users-form',
			'enableAjaxValidation' => true
	));
	echo '<div><span style="font-size:16px"><b>Staff :</b></span> '.$data->user_information->first_name.' '.$data->user_information->last_name.' ('.$data->username.')</div>';
	$roomStaffs = RoomStaff::model()->findAll(array('condition'=>"staff_id='".$data->id."'"));
	$roomIds = array();
	foreach($roomStaffs as $roomStaff){
		$roomIds[count($roomIds)] = $roomStaff->room_id;
	}
	foreach($rooms as $room) {
		echo '<div style="float:left; width: 200px;"><input type="checkbox" name="rooms[]" value="'.$room->id.'" '.(in_array($room->id, $roomIds) ? 'checked="checked"' : '').'>'.$room->name.'</div>';
	}
	?>
	<div class="clear"></div><br>
	<input type="submit" name="submit" value="Save"> 
	<?php $this->endWidget(); ?>
</div>





itech/protected/views/user/create.php
<div class="module-head">
	User - <span>Create New User</span>
</div>
<div>
	<?php 
	$form = $this->beginWidget('CActiveForm', array(
			'id' => 'users-form',
			'enableAjaxValidation' => true
	));
	?>
	<table class="simple-form">
		<tr class="seperate">
			<td colspan="2"><div>Login Information</div></td>
		</tr>
		<tr>
			<td class="column-left" width="20%">Username</td>
			<td class="column-right"><?php echo $form->textField(UserLogin::model(), 'username', array('size' => 20, 'maxlength' => 20)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left" width="20%">Password</td>
			<td class="column-right"><?php echo $form->passwordField(UserLogin::model(), 'password', array('size' => 20, 'maxlength' => 20)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left" width="20%">Re - Password</td>
			<td class="column-right"><input type="password" name="re-password"
				maxlength="20" size="20"></td>
		</tr>
		<tr>
			<td class="column-left">Email</td>
			<td class="column-right"><?php echo $form->textField(UserLogin::model(), 'email', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left" width="20%">Role</td>
			<td class="column-right"><select name="UserLogin[role_id]">
					<option value="">--Select--</option>
					<?php 
					$roles = Role::model()->findAll(array(
							'condition'=>'status != :status',
							'params'=>array(':status'=>'HIDDEN'),
					));
					foreach ($roles as $role) {
					?>
					<option value="<?php echo $role->id?>"
					<?php echo $model->role_id == $role->id ? 'selected="selected"' : ''?>><?php echo $role->name?></option>
					<?php }?>
			</select>
			</td>
		</tr>
		<tr class="seperate">
			<td colspan="2"><div>Personal Information</div></td>
		</tr>
		<tr>
			<td class="column-left">Personal Card ID</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'personal_card_id', array('size' => 20, 'maxlength' => 13)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">Personal Title</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'personal_title', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">First Name</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'first_name', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">Last Name</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'last_name', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">Gender</td>
			<td class="column-right"><select name="UserInformation[gender]">
					<option value="">--Select--</option>
					<option value="M">Male</option>
					<option value="F">Female</option>
			</select>
			</td>
		</tr>
		<tr class="seperate">
			<td colspan="2"><div>Contact Information</div></td>
		</tr>
		<tr>
			<td class="column-left">Address Line 1</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'address1', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">Address Line 2</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'address2', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">Sub-District</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'sub_district', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">District</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'district', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">Province</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'province', array('size' => 20, 'maxlength' => 255)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left">Postal Code</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'postal_code', array('size' => 20, 'maxlength' => 5)); ?>
			</td>
		</tr>
				<tr>
			<td class="column-left">Phone</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'phone', array('size' => 20, 'maxlength' => 20)); ?>
			</td>
		</tr>
				<tr>
			<td class="column-left">Mobile</td>
			<td class="column-right"><?php echo $form->textField(UserInformation::model(), 'mobile', array('size' => 20, 'maxlength' => 20)); ?>
			</td>
		</tr>
		<tr>
			<td class="column-left"></td>
			<td class="column-right"><input type="submit" name="add_user"
				value="Submit" /><?php echo CHtml::link('Cancel',array('User/'), array('class' => 'button_cancel'))?></td>
		</tr>
	</table>
	<?php $this->endWidget(); ?>
</div>





itech/protected/views/user/main.php
<div class="module-head">User</div>
<div>
	<?php 
	if(UserLoginUtil::hasPermission(array("FULL_ADMIN", "CREATE_USER"))){
		echo CHtml::link('Create New',array('user/create'), array('class'=>'add'));
	}
	?>

	<div class="search-box">
		<?php 
		$form = $this->beginWidget('CActiveForm', array(
				'id' => 'users-form',
				'method'=>'get',
				'action'=>'',
				'enableAjaxValidation' => false,
		));
		?>
		<input type="text" name="search_text" value="<?php echo $_GET['search_text']?>">
		<?php $this->endWidget(); ?>
	</div>
</div>

<div class="simple-grid">
	<table class="items">
		<thead>
			<tr>
				<th width="5%">#</th>
				<th width="15%">Username</th>
				<th width="15%">Title</th>
				<th width="15%">FirstName</th>
				<th width="15%">LastName</th>
				<th width="15%">Email</th>
				<th width="15%">Status</th>
				<th width="10%">Action</th>
			</tr>
		</thead>
		<tbody>
			<?php 
			$counter = 1;
			$dataProvider = $data->search();


			foreach ($dataProvider->data as $data) {
		?>
			<tr class="line-<?php echo $counter%2 == 0 ? '1' : '2'?>">
			<td class="center"><?php echo GridUtil::getDataIndex($dataProvider, $counter++)?></td>
				<td class="center"><?php echo $data->username?></td>
				<td class="center"><?php echo $data->user_information->personal_title?></td>
				<td class="center"><?php echo $data->user_information->first_name?></td>
				<td class="center"><?php echo $data->user_information->last_name?></td>
				<td class="center"><?php echo $data->user_information_email_search?></td>
				<td class="center"><?php echo $data->user_status->name?></td>
				<td class="center"><a title="View" class="ico-s-view"
					href="<?php echo Yii::app()->CreateUrl('User/view/id/'.$data->id)?>"></a>
					<a title="Edit" class="ico-s-edit"
					href="<?php echo Yii::app()->CreateUrl('User/update/id/'.$data->id)?>"></a>
					<a title="Delete"
					onclick="return confirm('Are you sure to delete?')"
					class="ico-s-delete"
					href="<?php echo Yii::app()->CreateUrl('User/delete/id/'.$data->id)?>"></a>
				</td>
			</tr>
			<?php 
		}
		?>
		</tbody>
	</table>
				<div class="paging">
				<?php GridUtil::RenderPageButton($this, $dataProvider); ?>
			</div>
</div>


<?php
/*
$this->widget('zii.widgets.grid.CGridView', array(
		'id' => 'my-model-grid',
		'dataProvider' => $data->search(),
		'ajaxUpdate'=>true,
		'columns' => array(
				array(
						'header'=>'#',
						'value'=>'$this->grid->dataProvider->pagination->currentPage*$this->grid->dataProvider->pagination->pageSize + $row+1',       //  row is zero based
						'htmlOptions'=>array('width'=>'5%', 'align'=>'center'),
				),
				array(
						'name'=>'username',
						'htmlOptions'=>array('width'=>'15%', 'align'=>'center'),
				),
				array(
						'header' => 'Title',
						'name'=>'user_information_personal_title_search',
						'value'=>'$data->user_information->personal_title',
						'htmlOptions'=>array('width'=>'10%'),
				),
				array(
						'header' => 'First Name',
						'name'=>'user_information_first_name_search',
						'value'=>'$data->user_information->first_name',
						'htmlOptions'=>array('width'=>'15%'),
				),
				array(
						'header' => 'Last Name',
						'name'=>'user_information_last_name_search',
						'value'=>'$data->user_information->last_name',
						'htmlOptions'=>array('width'=>'15%'),
				),
				array(
						'header' => 'Email',
						'name'=>'user_information_email_search',
						'value'=>'$data->email',
				),
				array(
						'header' => 'Role',
						'name'=>'role_name_search',
						'value'=>'$data->role->name',
						'htmlOptions'=>array('width'=>'8%', 'align'=>'center'),
				),
				array(
						'header' => 'Status',
						'name'=>'status_name_search',
						'value'=>'$data->user_status->name',
						'htmlOptions'=>array('width'=>'8%', 'align'=>'center'),
				),
				array(            // display a column with "view", "update" and "delete" buttons
						'class'=>'CButtonColumn',
						'template'=>'{view} {update} {delete}',
						'htmlOptions'=>array('width'=>'10%', 'align'=>'center'),
						'buttons'=>array
						(
								'view' => array
								(
										'visible'=>'UserLoginUtil::hasPermission(array("FULL_ADMIN", "VIEW_USER"))',
								),
								'update' => array
								(
										'visible'=>'UserLoginUtil::hasPermission(array("FULL_ADMIN", "UPDATE_USER"))',
								),
								'delete' => array
								(
										'visible'=>'UserLoginUtil::hasPermission(array("FULL_ADMIN", "DELETE_USER"))',
								),
						),
				),
		),
));
*/
?>

itech/protected/views/user/staff.php
<div class="module-head">Staff</div>
<div>

</div>

<div class="simple-grid">
	<table class="items">
		<thead>
			<tr>
				<th width="5%">#</th>
				<th width="15%">Username</th>
				<th width="15%">Title</th>
				<th width="15%">FirstName</th>
				<th width="15%">LastName</th>
				<th width="15%">Email</th>
				<th width="15%">Status</th>
				<th width="10%">Action</th>
			</tr>
		</thead>
		<tbody>
			<?php 
			$counter = 1;
			foreach ($data->search()->data as $data) {
		?>
			<tr class="line-<?php echo $counter%2 == 0 ? '1' : '2'?>">
				<td class="center"><?php echo $counter++?></td>
				<td class="center"><?php echo $data->username?></td>
				<td class="center"><?php echo $data->user_information->personal_title?></td>
				<td class="center"><?php echo $data->user_information->first_name?></td>
				<td class="center"><?php echo $data->user_information->last_name?></td>
				<td class="center"><?php echo $data->user_information_email_search?></td>
				<td class="center"><?php echo $data->user_status->name?></td>
				<td>
				<a title="Assign Rooms"" href="<?php echo Yii::app()->CreateUrl('User/AssignRoom/id/'.$data->id)?>">Assign Rooms</a>
				</td>
				
			</tr>
			<?php 
		}
		?>
		</tbody>
	</table>
</div>


<?php
/*
$this->widget('zii.widgets.grid.CGridView', array(
		'id' => 'my-model-grid',
		'dataProvider' => $data->search(),
		'ajaxUpdate'=>true,
		'columns' => array(
				array(
						'header'=>'#',
						'value'=>'$this->grid->dataProvider->pagination->currentPage*$this->grid->dataProvider->pagination->pageSize + $row+1',       //  row is zero based
						'htmlOptions'=>array('width'=>'5%', 'align'=>'center'),
				),
				array(
						'name'=>'username',
						'htmlOptions'=>array('width'=>'15%', 'align'=>'center'),
				),
				array(
						'header' => 'Title',
						'name'=>'user_information_personal_title_search',
						'value'=>'$data->user_information->personal_title',
						'htmlOptions'=>array('width'=>'10%'),
				),
				array(
						'header' => 'First Name',
						'name'=>'user_information_first_name_search',
						'value'=>'$data->user_information->first_name',
						'htmlOptions'=>array('width'=>'15%'),
				),
				array(
						'header' => 'Last Name',
						'name'=>'user_information_last_name_search',
						'value'=>'$data->user_information->last_name',
						'htmlOptions'=>array('width'=>'15%'),
				),
				array(
						'header' => 'Email',
						'name'=>'user_information_email_search',
						'value'=>'$data->email',
				),
				array(
						'header' => 'Status',
						'name'=>'status_name_search',
						'value'=>'$data->user_status->name',
						'htmlOptions'=>array('width'=>'8%', 'align'=>'center'),
				),
				array(
						'class'=>'CButtonColumn',
						'header'=>'',
						'template'=>'{Assign Rooms}',
						'htmlOptions'=>array('width'=>'15%', 'align'=>'center'),
						'buttons'=>array
						(
								'Assign Rooms' => array
								(
										'visible'=>'UserLoginUtil::hasPermission(array("FULL_ADMIN"))',
										'url'=>'Yii::app()->createUrl("User/AssignRoom/id/".$data->id)',
								),
						),
				),
		),
));
*/
?>

itech/protected/views/user/view.php
<div class="module-head">User</div>
<table class="simple-form">
	<tr class="seperate">
		<td colspan="2"><div>Login Information</div></td>
	</tr>
	<tr>
		<td class="column-left" width="20%">Username</td>
		<td class="column-right"><?php echo $model->username ?>
		</td>
	</tr>
	<tr>
		<td class="column-left" width="20%">Password</td>
		<td class="column-right">******</td>
	</tr>
	<tr>
		<td class="column-left">Email</td>
		<td class="column-right"><?php echo $model->email ?>
		</td>
	</tr>
	<tr>
		<td class="column-left" width="20%">Role</td>
		<td class="column-right"><?php echo $model->role->name ?>
		</td>
	</tr>
	<tr>
		<td class="column-left" width="20%">Status</td>
		<td class="column-right"><?php echo $model->user_status->name ?>
		</td>
	</tr>
	<tr class="seperate">
		<td colspan="2"><div>Personal Information</div></td>
	</tr>
	<tr>
		<td class="column-left">Personal Card ID</td>
		<td class="column-right"><?php echo $model->user_information->personal_card_id ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Personal Title</td>
		<td class="column-right"><?php echo $model->user_information->personal_title ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">First Name</td>
		<td class="column-right"><?php echo $model->user_information->first_name ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Last Name</td>
		<td class="column-right"><?php echo $model->user_information->last_name ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Gender</td>
		<td class="column-right"><?php echo UserInfoUtil::getGenderName($model->user_information->gender) ?>
		</td>
	</tr>
	<tr class="seperate">
		<td colspan="2"><div>Contact Information</div></td>
	</tr>
	<tr>
		<td class="column-left">Address Line 1</td>
		<td class="column-right"><?php echo $model->user_information->address1 ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Address Line 2</td>
		<td class="column-right"><?php echo $model->user_information->address2 ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Sub-District</td>
		<td class="column-right"><?php echo $model->user_information->sub_district ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">District</td>
		<td class="column-right"><?php echo $model->user_information->district ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Province</td>
		<td class="column-right"><?php echo $model->user_information->province ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Phone</td>
		<td class="column-right"><?php echo $model->user_information->phone ?>
		</td>
	</tr>
	<tr>
		<td class="column-left">Mobile</td>
		<td class="column-right"><?php echo $model->user_information->mobile ?>
		</td>
	</tr>
	<tr>
		<td class="column-left"></td>
		<td class="column-right"><?php 
		echo CHtml::link('Back',array('user/')).' | '; echo
		CHtml::link('Edit',array('user/update','id'=>$model->id)); ?>
		</td>
	</tr>
</table>

